<?php

class document {

   var $filename;

   var $source;
   var $attributes = array();

   var $content;
   var $options = array();

   function document($filename) {

     if (preg_match("/.*\.(register|config|cfg|lock|dat|htaccess)/Ui", $filename)) {
       $this->source = "<H1>FEHLER 403</H1><P>Datei &quot;$filename&quot; ist auf diesem Server nicht vorhanden und/oder nicht freigegeben</P>";
       unset($this->filename);
     } elseif (!file_exists($filename) || !is_readable($filename)) {
       $this->source = "<H1>FEHLER 404</H1><P>Datei &quot;$filename&quot; ist auf diesem Server nicht vorhanden</P>";
       unset($this->filename);
     } else {
       $this->attributes[mtime] = date("d.m.Y",filemtime($filename));
       $this->attributes[atime] = date("d.m.Y",fileatime($filename));
       $this->attributes[ctime] = date("d.m.Y",filectime($filename));
       clearstatcache();
       global $REMOTE_ADDR; if (isset($REMOTE_ADDR)) { $this->attributes[REMOTE_ADDR] = $REMOTE_ADDR; }
       $this->filename = $filename;
     }

   }

   function isEmpty() {
     return ($this->source=="");
   }

   function reset() {
     $this->content=$this->source;
     $this->options=$this->attributes;
   }

   function close() {
     foreach ($this as $key=>$element) {
       unset($this->$key);
     }
   }

   function read() {

     if ($this->filename=="") { return false; }

     $txt = file($this->filename);
     $txt = implode("", $txt);
     $this->source = $txt;
     $this->dateipfadeKorrigieren();
     $this->content = $this->source;
     $this->options = $this->attributes;
     return true;

   }

   function readBody() {

     if ($this->filename=="") { return false; }

     $txt = file($this->filename);
     $txt = implode("", $txt);
     $matches = array();
     if (preg_match("/<body[^>]*>(.*)<\/body>/Usi", $txt, $matches)) {
       $txt = $matches[1];
     }
     $this->source = $txt;
     $this->dateipfadeKorrigieren();
     $this->content = $this->source;
     $this->options = $this->attributes;
     return true;


   }

   function dateipfadeKorrigieren() {

     if (preg_match("/^.*\//", $this->filename, $match1)) {
       preg_match_all('/ background\s?=\s?"(\S*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/^http:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ background\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' background="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all('/ src\s?=\s?"(\S*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/ src\s?=\s?"\S*"/i', $match2[1][$i]) && !preg_match('/^http:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ src\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' src="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all("/\.src\s?=\s?'(\S*)'/i", $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match("/\.src\s?=\s?'\S*'/i", $match2[1][$i]) && !preg_match('/^http:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace("/\.src\s?=\s?'".$this->toRegExp($match2[1][$i])."'/i", ".src='".$match1[0].$match2[1][$i]."'", $this->source);
         }
       }
       preg_match_all("/ url\('([^']*)'\)/i", $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match("/ url\('[^']*'\)/i", $match2[1][$i]) && !preg_match('/^http:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace("/ url\('".$this->toRegExp($match2[1][$i])."'\)/i", " url('".$match1[0].$match2[1][$i]."')", $this->source);
         }
       }
       preg_match_all('/ href\s?=\s?"([^"]*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/ href\s?=\s?"\S*"/i', $match2[1][$i]) && !preg_match('/^javascript:/i', $match2[1][$i]) && !preg_match('/^\&\#109\;\&\#97\;\&\#105\;\&\#108\;\&\#116\;\&\#111\;\&\#58\;\S*/i', $match2[1][$i]) && !preg_match('/^mailto:\S*/i', $match2[1][$i]) && !preg_match('/^http:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ href\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' href="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all('/<?%IMPORT ([^%]*)%>?/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         $this->source = preg_replace('/<?%IMPORT '.$this->toRegExp($match2[1][$i]).'%>?/i', '%IMPORT '.$match1[0].$match2[1][$i].'%', $this->source);
       }
     }

   }

   function insert($include) {

     $this->insertAtTag($include, "eintraege");

   }

   function insertAtTag($include, $tag) {

     $matches = array();
     if (preg_match("/<head[^>]*>.*<\/head>/Usi", $include, $matches)) {
       $this->content = preg_replace("/<head[^>]*>.*<\/head>/Usi", $matches[0], $this->content);
       $include = preg_replace("/<head[^>]*>.*<\/head>/Usi", "", $include);
     }
     if (preg_match("/<body[^>]*>(.*)<\/body>/Usi", $include, $matches)) {
       $this->replace("%".$tag."%", $matches[1]);
     } else {
       $this->replace("%".$tag."%", $include);
     }

     $this->replace("%IF ".$tag."%", "");

   }
   
   function insertFileAtTag($include, $tag) {
     $temp = new document($include);
     $bool = $temp->readBody();
     $this->insertAtTag($temp->content,$tag);
     return $bool;
   }

   function insertFile($include) {
     $this->insertFileAtTag($include, "eintraege");
   }

   function fill($REF) {
     $this->content = fillTemplate($this->content, $REF);
   }

   function replace($token, $replace) {
     $this->content = preg_replace("/<?".$this->toRegExp($token).">?/Ui", $replace, $this->content);
   }

   function exec($REF) {
     $this->content = execCommands($this->content, $REF);
   }

   function toRegExp($string) {
     return toRegExp($string);
   }
   
   function doImports() {
       $match=array();
       preg_match_all('/<?%IMPORT ([^%]*)%>?/si', $this->content, $match);
       for ($i=0;$i<count($match[1]);$i++) {
         if (file_exists($match[1][$i])) {
           $this->insertFileAtTag($match[1][$i],"IMPORT ".$match[1][$i]);
         }
       }
   }

   function finalize() {
     // abstract method
   }

   function get() {

     $this->fill($this->options);
     $this->exec($this->options);
     $this->content = preg_replace("/<%COMMENT%>.*<%\/COMMENT%>/Usi", "", $this->content);
     $this->content = preg_replace("/<?%\/?(\w?)*%>?/i", "", $this->content);
     return $this->content;

   }

   function write() {

     global $lcn_note, $copyright, $LICENCE;
     if (isset($LICENCE['key']) && $LICENCE['key'] != "") { $this->content = preg_replace("/<\/body>/i", $lcn_note."</body>", $this->content);
     } else {                                               $this->content = preg_replace("/<\/body>/i", $copyright."</body>", $this->content); }

     $this->doImports();
     $this->finalize();

     echo $this->get();
   
   }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
