<?php

function embeddedTags($txt) {

  settype($txt, "string");

  $txt = preg_replace("/\[url\]http:\/\//i","[url]",$txt);
  $txt = preg_replace("/\[mail\]mailto:/i","[mail]",$txt);
  $txt = preg_replace("/\[b\]/i", '<strong>', $txt);
  $txt = preg_replace("/\[\/b\]/i", '</strong>', $txt);
  $txt = preg_replace("/\[i\]/i", '<em>', $txt);
  $txt = preg_replace("/\[\/i\]/i", '</em>', $txt);
  $txt = preg_replace("/\[u\]/i", '<u>', $txt);
  $txt = preg_replace("/\[\/u\]/i", '</u>', $txt);
  $txt = preg_replace("/\[emp\]/i", '<span class="EMPHASIZE">', $txt);
  $txt = preg_replace("/\[\/emp\]/i", '</span>', $txt);
  $txt = preg_replace("/\[h\]/i", '<p class="HIGHLIGHT">', $txt);
  $txt = preg_replace("/\[\/h\]/i", '</p>', $txt);
  $txt = preg_replace("/\[img\]/i", '<img border=0 src="', $txt);
  $txt = preg_replace("/\[\/img\]/i", '">', $txt);
  $txt = preg_replace("/\[br\]/i", '<br>', $txt);
  $txt = preg_replace("/\[wbr\]/i", '<wbr>', $txt);
  $matches = array();
  while (preg_match("/\[mark=(.*)\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[mark='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]/Ui', '<span style="background-color:'.strip_tags(preg_replace('/;.*/', ';', $matches[1])).'">', $txt);
  }
  $txt = preg_replace("/\[mark\]/i", '<span style="background-color:yellow">', $txt);
  $txt = preg_replace("/\[\/mark\]/i", '</span>', $txt);
  $matches = array();
  while (preg_match("/\[color=(.*)\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[color='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]/Ui', '<span style="color:'.strip_tags(preg_replace('/;.*/', ';', $matches[1])).'">', $txt);
  }
  $txt = preg_replace("/\[color\]/i", '<span style="color:black">', $txt);
  $txt = preg_replace("/\[\/color\]/i", '</span>', $txt);
  $txt = preg_replace("/\[code\]/i", '<code>', $txt);
  $txt = preg_replace("/\[\/code\]/i", '</code>', $txt);
  $matches = array();
  while (preg_match("/\[mail\](.*)\[\/mail\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[mail\]'.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\[\/mail\]/Ui', '<a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;'.htmlentities(strip_tags($matches[1])).'" target="_blank">'.$matches[1].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[mail=(.*)\](.*)\[\/mail\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[mail='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]'.addcslashes($matches[2], "+()[]{}.?*/\\$^").'\[\/mail\]/Ui', '<a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;'.htmlentities(strip_tags($matches[1])).'" target="_blank">'.$matches[2].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[url=(.*)\](.*)\[\/url\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[url='.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\]'.addcslashes($matches[2], "+()[]{}.?*/\\$^").'\[\/url\]/Ui', '<a href="http://'.htmlentities(strip_tags($matches[1])).'" target="_blank">'.$matches[2].'</a>', $txt);
  }
  $matches = array();
  while (preg_match("/\[url\](.*)\[\/url\]/Ui", $txt, $matches)) {
    $txt = preg_replace('/\[url\]'.addcslashes($matches[1], "+()[]{}.?*/\\$^").'\[\/url\]/Ui', '<a href="http://'.htmlentities(strip_tags($matches[1])).'" target="_blank">'.$matches[1].'</a>', $txt);
  }

  return $txt;
}

function addSmilies($txt) {

  settype($txt, "string");
  global $smilies; global $DIR;

  // Standard-Smilies
  if (isset($smilies) && is_array($smilies)) {
    if (in_array("smile", $smilies))        { $txt = preg_replace("/:[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'smile.gif">', $txt); }
    if (in_array("teufelchen", $smilies))   { $txt = preg_replace("/>:[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'teufelchen.gif">', $txt); }
    if (in_array("boese", $smilies))        { $txt = preg_replace("/:[\-_o_O]?\(/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'boese.gif">', $txt); }
    if (in_array("keinemeinung", $smilies)) { $txt = preg_replace("/:[\-_o_O]?\|/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'keinemeinung.gif">', $txt); }
    if (in_array("lachen", $smilies))       { $txt = preg_replace("/:[\-_o_O]?D/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'lachen.gif">', $txt); }
    if (in_array("grinsen", $smilies))      { $txt = preg_replace("/;[\-_o_O]?\)/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'grinsen.gif">', $txt); }
    if (in_array("zunge", $smilies))        { $txt = preg_replace("/:[\-_o_O]?P/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'zunge.gif">', $txt); }
    if (in_array("traurig", $smilies))      { $txt = preg_replace("/:[\'_\*]\(/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].'traurig.gif">', $txt); }
  }

  // Emot-Codes                     
  for ($j=0;$j<count($smilies);$j++) {
    while (preg_match("/:".$smilies[$j].":(\s|\[wbr\]|\[br\]|<br \/>)*:".$smilies[$j].":/i", $txt)) {
      $txt = preg_replace("/:".$smilies[$j].":(\s|\[wbr\]|\[br\]|<br \/>)*:".$smilies[$j].":/i", ':'.$smilies[$j].':', $txt);
    }
    $txt = preg_replace("/:".addcslashes($smilies[$j], "+()[]{}.?*/\\$^").":/", '<img border=0 hspace=2 src="'.$DIR["smilies.dir"].$smilies[$j].'.gif">', $txt);
  }

  return $txt;
}

function loadSmilies($smileyDir) {

  settype($smileyDir, "string");
  global $smilies; $DIR;
  $smilies = array();
  $DIR["smilies.dir"] = "$smileyDir";

  $dir = dir($smileyDir);
  while ($txt = $dir -> read()) {
    if (preg_match("/\.gif$/i", $txt)) {
      $smilies[count($smilies)] = preg_replace("/\..*/", "", $txt); }
  }
  $dir -> close();
  sort($smilies);

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
