<?php

/****************************
 Common tools
****************************/

function dirlist($dir, $filter) {

  $dirlist = array();
  $dir = dir($dir);
  while($entry=$dir->read()) {
    if (!in_array($entry, $dirlist) && preg_match("/".toRegExp($filter)."$/i",$entry)){
       $dirlist[count($dirlist)]=$entry;
    }
  }
  $dir->close();
  sort($dirlist);
  return $dirlist;

}

function toRegExp($string) {
  return addcslashes($string, "+()[]{}.?*/\\");
}

/****************************
 Template tools
****************************/

function fillTemplate($template, $REF) {

  settype($template, "string");
  if (isset($REF) && $REF!="") {
    preg_match_all("/<%FOREACH ([^%]+)%>(.*)<%\/ENDFOR%>/Usi", $template, $matches);
    for ($i=0;$i<count($matches[0]);$i++) {
      $temp = fillEach($matches[2][$i],$REF[$matches[1][$i]]);
      $template = preg_replace("/".toRegExp($matches[0][$i])."/", "<%FOREACH ".$matches[1][$i]."%>".$temp."<%ENDFOR/%>", $template);
    };
    foreach ($REF as $key=>$element) {
      settype($element, "string");
		  $token = scanForAt(embeddedTags($element));
		  $template = preg_replace("/<?%".$key."%>?/i", $token, $template);
    }
  }

 return $template;
}

function fillEach($template, $REF) {

  settype($template, "string");
  $document = new document("");
  $document->content = $document->source = $template;

  $text = "";
  foreach ($REF as $key=>$element) {
    $document->options = $element;
    $text .= $document->get();
    $document->reset();
  }

 return $text;
}

function execCommands($txt, $REF) {

  settype($txt, "string");
  foreach ($REF as $key=>$element) {
    settype($element, "string");
    $REF[strtoupper($key)] = $element;
  }

  $txt = preg_replace("/\n/", '<NEW_LINE>', $txt);

  $txt = preg_replace("/\[(%IF.*%)\]/Ui", "<\\1>", $txt);
  $txt = preg_replace("/\[%ELSE%\]/Ui", "<%ELSE%>", $txt);
  $txt = preg_replace("/\[%\/ENDIF%\]/Ui", "<%/ENDIF%>", $txt);

  $matches = array();

  preg_match_all("/<%IF ((\w+)==(\w+))%>/Ui", $txt, $matches);

  for ($i=0;$i<count($matches[1]);$i++) {
    if ($REF[strtoupper($matches[2][$i])]==$matches[3][$i]) {
        $REF[$matches[1][$i]] = true;
    }
  }

  $matches = array();

  preg_match_all("/<%IF ((\w+)!=(\w+))%>/Ui", $txt, $matches);

  for ($i=0;$i<count($matches[1]);$i++) {
    if ($REF[strtoupper($matches[2][$i])]!=$matches[3][$i]) {
        $REF[$matches[1][$i]] = true;
    }
  }

  if (isset($REF) && $REF!="") {
    foreach ($REF as $key=>$element) {
      $matches = array();
      while (preg_match("/<%IF ".addcslashes($key, "+()[]{}.?*/\\$^")."%>(.*)<%\/ENDIF%>/Ui", $txt, $matches)) {
        $old = $txt;
        if (preg_match("/<%ELSE%>/i", $matches[1])) {
          if (isset($element) && $element != "") {
            $matches[1] = preg_replace("/<%ELSE%>.*/i", "", $matches[1]);
          } else {
            $matches[1] = preg_replace("/.*<%ELSE%>/i", "", $matches[1]);
          }
        } else {
          if (! isset($element) || $element == "") {
            $matches[1] = "";
          }
        }
        $txt = preg_replace("/".addcslashes($matches[0], "+()[]{}.?*/\\$^")."/Ui", $matches[1], $txt);
        if ($old==$txt) { break; };
      }
    }
  }
  $txt = preg_replace("/<%IF [^%]*%>.*(<%ELSE%>|<%\/ENDIF%>)/Ui", "", $txt);
  $txt = preg_replace("/<%\/ENDIF%>/Ui", "", $txt);
  $txt = preg_replace("/<NEW_LINE>/i", "\n", $txt);

  return $txt;
}

/****************************
 Mail tools
****************************/

function htmlEntitiesOnly($string) {

  settype($string, "string");
  for ($i=0;$i<strlen($string);$i++) {
    $out .= "&#".ord(substr($string, $i,1)).";";
  };

  return $out;

};

function scanForAt($string) {

  settype($string, "string");
  preg_match_all("/[\w\.\-_]+@[\w\.\-_]+/", $string, $matches);

  for ($i=0; $i<count($matches[0]); $i++) {
    $string = str_replace($matches[0][$i], htmlEntitiesOnly($matches[0][$i]), $string);
  }

  return $string;

};

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
