<?php

/**********************************************************************************************
**   Suchmaschine
**
**   Autor: Thomas Meyer
**
**   nicht fr Firmen oder kommerzielle Nutzung, keine unerlaubte Weitergabe, kein Verkauf
**
**   Diese Datei NICHT editieren !!!
**
**   Falls sie Anpassungen vornehmen wollen, benutzen sie ausschliesslich die dafr
**   vorgesehenen Skin- und Konfigurationsdateien in den Verzeichnissen "skins/" und "config/" !!!
**
**    2004, Thomas Meyer www.All-Community.de - Copyright Hinweis nicht entfernen!
**
***********************************************************************************************/

include('includes/class_document.php');
include('includes/config.php');
include('includes/toolbox.php');
include('includes/count.php');
require('includes/tags_and_icons.php');
require('includes/xsuchmaschine.php');

// BEGINN - Init
$begriff = trim($begriff);
load_plugins();

// Importiere Konfiguration
$DIR["config.file"]     = "$cfgDir$id".".cfg";
$DIR["config.default"]  = $cfgDir."_default.config";

if (file_exists($DIR["config.file"]) && is_readable($DIR["config.file"])) { importConfigFile($DIR["config.file"]);
} else { importConfigFile($DIR["config.default"]); }

importConfigFile($CONFIG["skin"]);
importConfigFile($CONFIG["langFile"]);
// ENDE

$trefferliste = array();
$dokumente = array();
$cache = array();
$sucheNach = "";
$cacheFile = $CONFIG["suchDir"]."_default.cache";

$template = new document($SKIN["default.html"]);
$template->read();
$template->options["CLASS"] = (isset($class) && $class != "") ? $class : "empty";
$template->options["ID"] = $id;
$template->options["PHP_SELF"] = "suchmaschine.php";
$template->options["JS_DIR"] = preg_replace("/(.*\/).*/", "$1", $CONFIG["langFile"]);
$template->options = array_merge($template->options, $TEXT);

// ENDE - Init

if (isset($action) && $action == "start") {
  start();
} elseif(isset($action) && $action == "stats") {
  stats();
} else {
  $template->write();
}

/* METHOD: POST
** --------------------------
** IN:  STRING $begriff  -Suchbegriffe als durch ' ' getrennte Liste
**      STRING $class    -CSS Klassenname
**      STRING $template -Dateiname oder URL
** --------------------------
** OUT: VOID
*/
function start() {

  global $begriff, $template, $sucheNach, $trefferliste, $suchmaschine, $CONFIG, $TEXT;

  $temp = explode(" ", strtolower($begriff));
  for ($i=0; $i<count($temp); $i++) {
    counter(encodeString($temp[$i]),$CONFIG["suchDir"],$temp[$i]);
  }

  if (!inCache($begriff)) { suche($begriff); }

  $ausgabe = '<P CLASS="KOMMENTAR">'.$TEXT[searchfor].' <b>'.$sucheNach.'</b></P>'."\n";

  $trefferAnzahl = 0;
  $script = "";

  for ($i=0; $i<count($trefferliste); $i++) {
    if (count($trefferliste[$i])>0 && isset($trefferliste[$i][0]) && $trefferliste[$i][0] != "\n") {
      $trefferAnzahl++;
      $script .= '  trefferliste[trefferliste.length] = \''.preg_replace("/%/", "#", rawurlencode('<P CLASS="ACOMMENT"><B><A HREF="'.$CONFIG["prefix"]. htmlentities(preg_replace("/^.\//", "", preg_replace("/^\n/", "", $trefferliste[$i][0]))) .'" TARGET="'.$CONFIG[target].'">'. $trefferliste[$i][1] .'</A></B><BR><SPAN CLASS="BESCHREIBUNG">'. $trefferliste[$i][2] .'</SPAN></P>')).'\';'."\n";
    };
  };

  $template->options["InsertResultsHere"] = $ausgabe;
  $template->options["SCRIPT"] = $script;
  $template->replace("</body>", "<script type=\"text/javascript\">show(0,'suchergebnis')</script>\n</body>");
  $template->write();

}

/**********************************************************************************************
** interne Funktionen
***********************************************************************************************/

function stats() {

  global $CONFIG,$TEXT,$template,$suchmaschine;

  $ausgabe="<H2>".$TEXT["stats_name"]."</H2>";
  $zahlen=array();
  $statistik=array();

  if (!file_exists($CONFIG["suchDir"].'statistik.cnt')) {
    meldung("stats.error");
  }

  $zahlen = file($CONFIG["suchDir"].'statistik.cnt');

  for ($i = 0; $i < count($zahlen) && $i<100; $i++) {
    $zahlen[$i] = explode('=',$zahlen[$i]);
    if (count($zahlen[$i]) > 2 && strlen($zahlen[$i][2]) > 1) {
      $statistik[rawurldecode($zahlen[$i][2])]=$zahlen[$i][1];
    } else {
      $statistik[$zahlen[$i][0]]=$zahlen[$i][1];
    }
  }
  
  arsort($statistik, SORT_NUMERIC);
  $ausgabe.= '<TABLE width=400 cellspacing=0 cellpadding=8 class="STATISTIK">'."\n";

  $i=1; $prevVal=0;
  while(list($key, $val) = each($statistik)){
    $ausgabe.= "\t".'<TR' .( ($i%2==1) ? ' class="STATISTIK1"' : ' class="STATISTIK2"' ). '><TH CLASS="SUCHBEGRIFF" align=left>'. ( ($prevVal==0 ||($val*1)<$prevVal) ? '<P>'.$TEXT["stats_score"].' '.$i.':</P>' : '&nbsp;' ) .'</TH>'."\n\t".'<TD align=right class="BESCHREIBUNG"><P>'. $key . '</P></TD>'."\n\t".'<TD align=right class="KOMMENTAR">' . ($val*1) . ' '. ( ($val>1) ? $TEXT["stats_hits"] : $TEXT["stats_hit"] ) .'</TD></TR>'."\n";
    $prevVal=$val*1;
    $i++;
  }
  $ausgabe.= "</TABLE>\n";

  $template->options["InsertResultsHere"] = $ausgabe;
  $template->write();
}

function suche($begriff) {

  global $trefferliste, $dokumente, $CONFIG, $TEXT, $sucheNach;
  $gefunden = 0; $treffer = array(); $trefferliste = array();

  $anfrage = explode(" ", $begriff);

  if (!file_exists($CONFIG[keyFile]) || !file_exists($CONFIG[docFile])) {
    meldung("search.error");
  }

		$file = file($CONFIG[keyFile]);
		$file[0] = preg_replace("/\n/", "", $file[0]);
  $file = explode(", ", $file[0]);

		for ($i = 0; $i < count($anfrage); $i++) {

    $enc_string  = encodeString($anfrage[$i]);
    $gefunden				= false;
				$max 								= count($file)-1;
				$min									= 0;
				$n 										= floor($max /2);
				$prev_n						= array(-1,-1);

    while (!$gefunden && $max != $min) {
			$temp2 = preg_replace("/=.*/i", "", $file[$n]);
			$temp2 = strcasecmp($temp2, $enc_string);
			if ($temp2>0) {
				$max = $n;
			} else if ($temp2<0) {
				$min = $n;
			} else {
				$treffer[$anfrage[$i]]=explode("\"", preg_replace("/.*=/i", "", $file[$n]));
        $whatsRelated = trim(preg_replace("/\|/", " ", preg_replace("/~/", $enc_string, $treffer[$anfrage[$i]][0])));
        $whatsRelated = preg_replace("/\s\s/", " ", $whatsRelated);
        $sucheNach .= '<br>'.$anfrage[$i] . ( $treffer[$anfrage[$i]][0] != "" && $anfrage[$i] != $whatsRelated ? ' &nbsp; &nbsp; <small><a href="javascript:whatsRelated()" target="_self">'.$TEXT["related"].'</a> <span style="font-weight: normal">' . $whatsRelated . '</span></small>' : '' );
        $gefunden = true;
			}

      array_shift($prev_n);
			$prev_n[count($prev_n)] = $n;

			if ($min!=$n) {
					$n = $min + floor( ($max-$min) /2 );
			} else {
					$n = $min + ceil( ($max-$min) /2 );
			}
						
			if ($prev_n[0]==$n||$prev_n[1]==$n) { $treffer[$anfrage[$i]][0]= ""; break; }

    }

		}

  if (count($treffer)>0) {
     array_shift($treffer[$anfrage[0]]); // 0. Treffer ist immer leer -> also weg damit!
     $trefferliste=$treffer[$anfrage[0]];
  }

  // BEGINN: UND -Verknpfung
	for ($i=1;$i<count($anfrage);$i++) {
		$myTemp = array();
		for ($j=1;$j<count($treffer[$anfrage[$i]]);$j++) {
			if(in_array($treffer[$anfrage[$i]][$j], $trefferliste)) {
				$myTemp[count($myTemp)] = $treffer[$anfrage[$i]][$j];
			};
		};
		$trefferliste = $myTemp;
	};
  // ENDE: UND -Verknpfung

  // BEGINN: Liste der Dokumente laden
  $dokumente = array();
  $zeile=0;

  $file = fopen($CONFIG[docFile], "r");
  flock($file,1);
  while (!feof($file)) {
    $temp = fgetc($file);
    if ($temp == ']') {
      if (in_array((int) $zeile, $trefferliste)) {
        $dokumente[$zeile] = explode(',',$buffer);
      }
      $buffer="";
      $zeile++;
    } else {
      $buffer .= $temp;
    }
  }
  flock($file, 3);
  fclose($file);
  // ENDE: Liste der Dokumente laden

  if (count($trefferliste)<1) {
    $sucheNach = $begriff;
  } else {
    // IDs auflsen
    sort($anfrage);
    moveToCache(implode(" ", $anfrage), $trefferliste);
    for ($i=0; $i<count($trefferliste); $i++) {
      if (isset($trefferliste[$i]) && $trefferliste[$i] != "") {
        $trefferliste[$i] = $dokumente[(int) $trefferliste[$i]];
      }
    };
  };

}

function inCache($key) {

  global $cacheFile;
  global $cache;
  global $sucheNach;
  global $trefferliste;

  if (file_exists($cacheFile) && is_readable($cacheFile)) {
    $cache = file($cacheFile);
  } else {
    return false;
  }

  $temp = array();
  $temp = explode(" ", $key);
  for ($i=0;$i<sizeOf($temp);$i++) {
    $temp[$i] = encodeString($temp[$i]);
  }
  sort($temp);
  $key = implode(" ", $temp);
  $temp = "";
  for ($i=0;$i<sizeOf($cache);$i++) {
    if (preg_match("/^".$key."=/i", $cache[$i])) {
      $temp = preg_replace("/^".$key."=/", "", $cache[$i]);
      break;
    }
  }

  if ($temp != "") {
    $temp = explode(";", $temp);
    $sucheNach = rawurldecode($temp[0]);
    for ($i=1;$i<sizeOf($temp);$i++) {
      $trefferliste[count($trefferliste)] = explode(',',rawurldecode($temp[$i]));
    }
    return true;
  } else {
    return false;
  }
}

function moveToCache($key, $value){

  global $cacheFile;
  global $cache;
  global $dokumente;
  global $sucheNach;
  if (sizeOf($cache)>30) { array_pop($cache); };

  $text = $key.'='.rawurlencode($sucheNach).";";

  for ($i=0; $i<count($value); $i++) {
    if (isset($dokumente[$value[$i]])) {
      $text .= rawurlencode(trim(preg_replace("/\s/s", " ", implode(",", $dokumente[$value[$i]])))).";";
    }
  }

  $text .= "\n" . implode("", $cache);

  if (! file_exists($cacheFile)) {
    $datei = fopen($cacheFile, "w+"); flock($datei, 2);
    fwrite($datei, $text);
    flock($datei, 3); fclose($datei);
  } elseif (is_writeable($cacheFile)) {
    $datei = fopen($cacheFile, "w+"); flock($datei, 2);
    fwrite($datei, $text);
    flock($datei, 3); fclose($datei);
  } else {
    return false;
  }

  return true;

}

function encodeString($inputString) {

  $inputString = strtolower($inputString);

  $inputString = preg_replace("//", 'a', $inputString);
  $inputString = preg_replace("//", 'a', $inputString);
  $inputString = preg_replace("/\&Auml;/i", 'a', $inputString);
  $inputString = preg_replace("/\&auml;/i", 'a', $inputString);
  $inputString = preg_replace("//", 'u', $inputString);
  $inputString = preg_replace("//", 'u', $inputString);
  $inputString = preg_replace("/\&Uuml;/i", 'u', $inputString);
  $inputString = preg_replace("/\&uuml;/i", 'u', $inputString);
  $inputString = preg_replace("//", 'o', $inputString);
  $inputString = preg_replace("//", 'o', $inputString);
  $inputString = preg_replace("/\&Ouml;/i", 'o', $inputString);
  $inputString = preg_replace("/\&ouml;/i", 'o', $inputString);
  $inputString = preg_replace("//i", 'ss', $inputString);
  $inputString = preg_replace("/\&szlig;/i", 'ss', $inputString);
  $inputString = preg_replace("/\&nbsp;/i", ' ', $inputString);
  $inputString = preg_replace("/[^\w_\s]/Ui", '', $inputString);

  if ($inputString=="und" || $inputString=="hin" || $inputString=="her" || $inputString=="you" ||$inputString=="dort" ||$inputString=="hier" ||$inputString=="bis" ||$inputString=="oder" || $inputString=="aber" || $inputString=="et" || $inputString=="cetera" ||$inputString=="etc" || $inputString=="usw" || $inputString=="bzw" || $inputString=="beziehungsw" || $inputString=="beziehungsweise" || $inputString=="weiterer" || $inputString=="weiter" || $inputString=="weitere" || $inputString=="weiteren" || $inputString=="wer" || $inputString=="wie" || $inputString=="was" || $inputString=="zum" || $inputString=="sich" || $inputString=="mit" || $inputString=="und" || $inputString=="dem" || $inputString=="denen" || $inputString=="deren" || $inputString=="dessen" || $inputString=="von" || $inputString=="der" || $inputString=="die" || $inputString=="das" || $inputString=="ich" || $inputString=="sie" || $inputString=="wir" || $inputString=="ihr" || $inputString=="ihnen" || $inputString=="ihren" || $inputString=="deinen" || $inputString=="den" || $inputString=="des" || $inputString=="ihn" || $inputString=="ihm") {
      $inputString = "";
  } else {

      if (preg_match("/^selbst/i", $inputString) && strlen($inputString) > 6) { $inputString = substr($inputString, 6, strlen($inputString));
      } else if (preg_match("/^gross/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^durch/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^gegen/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^haupt/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^neben/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^unter/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^nacht/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^klein/i", $inputString) && strlen($inputString) > 5) { $inputString = substr($inputString, 5, strlen($inputString));
      } else if (preg_match("/^orts/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
      } else if (preg_match("/^voll/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
      } else if (preg_match("/^fern/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
      } else if (preg_match("/^ober/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
      } else if (preg_match("/^nach/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString));
      } else if (preg_match("/^uber/i", $inputString) && strlen($inputString) > 4) { $inputString = substr($inputString, 4, strlen($inputString)); };

      if (preg_match("/lichkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-10);
      } else if (preg_match("/igkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-8);
      } else if (preg_match("/igkeit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/lichkeiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-10);
      } else if (preg_match("/lichkeit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-8);
      } else if (preg_match("/lichen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/lichem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/ungen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-5);
      } else if (preg_match("/ungem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-5);
      } else if (preg_match("/iges$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/igen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/igem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/keiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/keit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
      } else if (preg_match("/lichen$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/lichem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/lich$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
      } else if (preg_match("/heiten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-6);
      } else if (preg_match("/innen$/Ui", $inputString) && $inputString != "innen") { $inputString = substr($inputString, 0, strlen($inputString)-5);
      } else if (preg_match("/enden$/Ui", $inputString) && $inputString != "enden") { $inputString = substr($inputString, 0, strlen($inputString)-5);
      } else if (preg_match("/end$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/ende$/Ui", $inputString) && $inputString != "ende") { $inputString = substr($inputString, 0, strlen($inputString)-4);
      } else if (preg_match("/heit$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-4);
      } else if (preg_match("/ung$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/tum$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/ten$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/tem$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/ers$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/ern$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-3);
      } else if (preg_match("/em$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/en$/Ui", $inputString)) {$inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/er$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/es$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/te$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/ts$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-2);
      } else if (preg_match("/t$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1);
      } else if (preg_match("/e$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1);
      } else if (preg_match("/s$/Ui", $inputString)) { $inputString = substr($inputString, 0, strlen($inputString)-1); };
      $inputString = preg_replace("/ /", "", $inputString);
  };

  return trim($inputString);

};

?>
